const { contextBridge, ipcRenderer } = require('electron')

contextBridge.exposeInMainWorld('bridge', {
	isElectron: true,
	nativeButton: (windowId, action) => {
		return new Promise((resolve) => {
			ipcRenderer.send('nativeButton', JSON.stringify({ windowId, action }))
			ipcRenderer.once('nativeButton', (event, message) => resolve(message))
		})
	},
	newBrowserWindow: (type) => {
		return new Promise((resolve) => {
			ipcRenderer.send('newBrowserWindow', JSON.stringify({ type: type }))
			ipcRenderer.once('newBrowserWindow', (event, message) => resolve(message))
		})
	},
	searchHints: (searchEngine, query) => {
		return new Promise((resolve) => {
			ipcRenderer.send(
				'searchHints',
				JSON.stringify({ searchEngine: searchEngine, query: query }),
			)
			ipcRenderer.once('searchHints', (event, message) => resolve(message))
		})
	},
	onInitial: (cb) => {
		ipcRenderer.on('onInitial', (e, msg) => {
			cb(msg)
		})
	},
})
